autogen.sh 8.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242
  1. #!/bin/sh
  2. #
  3. # ngIRCd -- The Next Generation IRC Daemon
  4. # Copyright (c)2001-2015 Alexander Barton (alex@barton.de) and Contributors
  5. #
  6. # This program is free software; you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation; either version 2 of the License, or
  9. # (at your option) any later version.
  10. # Please read the file COPYING, README and AUTHORS for more information.
  11. #
  12. # Usage:
  13. # [VAR=<value>] ./autogen.sh [<configure-args>]
  14. #
  15. # This script generates the ./configure script using GNU automake and
  16. # GNU autoconf. It tries to be smart in finding the correct/usable/available
  17. # installed versions of these tools on your system.
  18. #
  19. # In addition, it enables or disables the "de-ANSI-fication" support of GNU
  20. # automake, which is supported up to autoconf 1.11.x an has been removed
  21. # in automake 1.12 -- make sure to use a version of automake supporting it
  22. # when generating distribution archives!
  23. #
  24. # The following strategy is used for each of aclocal, autoheader, automake,
  25. # and autoconf: first, "tool" (the regular name of the tool, e. g. "autoconf"
  26. # or "automake") is checked. If this fails, "tool<major><minor>" (for example
  27. # "automake16") and "tool-<major>.<minor>" (e. g. "autoconf-2.54") are tried
  28. # with <major> being 2 for tool of GNU autoconf and 1 for tools of automake;
  29. # <minor> is tried from 99 to 0. The first occurrence will be used.
  30. #
  31. # When you pass <configure-args> to autogen.sh it will call the generated
  32. # ./configure script on success and pass these parameters to it.
  33. #
  34. # You can tweak the behaviour using these environment variables:
  35. #
  36. # - ACLOCAL=<cmd>, AUTOHEADER=<cmd>, AUTOMAKE=<cmd>, AUTOCONF=<cmd>
  37. # Name and optionally path to the particular tool.
  38. # - PREFIX=<path>
  39. # Search the GNU autoconf and GNU automake tools in <path> first. If the
  40. # generated ./configure script will be called, pass "--prefix=<path>" to it.
  41. # - EXIST=<tool>
  42. # Use <tool> to test for aclocal, autoheader etc. pp. ...
  43. # When not specified, either "type" or "which" is used.
  44. # - VERBOSE=1
  45. # Output the detected names of the GNU automake and GNU autoconf tools.
  46. # - GO=1
  47. # Call ./configure even if no arguments have been passed to autogen.sh.
  48. #
  49. # Examples:
  50. #
  51. # - ./autogen.sh
  52. # Generates the ./configure script.
  53. # - GO=1 ./autogen.sh
  54. # Generates the ./configure script and runs it as "./configure".
  55. # - VERBOSE=1 ./autogen.sh --with-ident
  56. # Show tool names, generates the ./configure script, and runs it with
  57. # these arguments: "./configure --with-ident".
  58. # - ACLOCAL=aclocal-1.6 GO=1 PREFIX=$HOME ./autogen.sh
  59. # Uses "aclocal-1.6" as aclocal tool, generates the ./configure script,
  60. # and runs it with these arguments: "./configure --prefix=$HOME".
  61. #
  62. Search()
  63. {
  64. [ $# -eq 2 ] || exit 1
  65. searchlist="$1"
  66. major="$2"
  67. minor=99
  68. [ -n "$PREFIX" ] && searchlist="${PREFIX}/$1 ${PREFIX}/bin/$1 $searchlist"
  69. for name in $searchlist; do
  70. $EXIST "${name}" >/dev/null 2>&1
  71. if [ $? -eq 0 ]; then
  72. "${name}" --version 2>&1 \
  73. | grep -v "environment variable" >/dev/null 2>&1
  74. if [ $? -eq 0 ]; then
  75. echo "${name}"
  76. return 0
  77. fi
  78. fi
  79. done
  80. while [ $minor -ge 0 ]; do
  81. for name in $searchlist; do
  82. $EXIST "${name}${major}${minor}" >/dev/null 2>&1
  83. if [ $? -eq 0 ]; then
  84. echo "${name}${major}${minor}"
  85. return 0
  86. fi
  87. $EXIST "${name}-${major}.${minor}" >/dev/null 2>&1
  88. if [ $? -eq 0 ]; then
  89. echo "${name}-${major}.${minor}"
  90. return 0
  91. fi
  92. done
  93. minor=$(expr $minor - 1)
  94. done
  95. return 1
  96. }
  97. Notfound()
  98. {
  99. echo "Error: $* not found!"
  100. echo 'Please install supported versions of GNU autoconf, GNU automake'
  101. echo 'and pkg-config: see the INSTALL file for details.'
  102. exit 1
  103. }
  104. Run()
  105. {
  106. [ "$VERBOSE" = "1" ] && echo " - running \"$*\" ..."
  107. "$@"
  108. }
  109. # Reset locale settings to suppress warning messages of Perl
  110. unset LC_ALL
  111. unset LANG
  112. # Which command should be used to detect the automake/autoconf tools?
  113. [ -z "$EXIST" ] && existlist="type which" || existlist="$EXIST"
  114. EXIST=""
  115. for t in $existlist; do
  116. $t /bin/ls >/dev/null 2>&1
  117. if [ $? -eq 0 ]; then
  118. rm -f /tmp/test.$$
  119. $t /tmp/test.$$ >/dev/null 2>&1
  120. [ $? -ne 0 ] && EXIST="$t"
  121. fi
  122. [ -n "$EXIST" ] && break
  123. done
  124. if [ -z "$EXIST" ]; then
  125. echo "Didn't detect a working command to test for the autoconf/automake tools!"
  126. echo "Searchlist: $existlist"
  127. exit 1
  128. fi
  129. [ "$VERBOSE" = "1" ] && echo "Using \"$EXIST\" to test for tools."
  130. # Try to detect the needed tools when no environment variable already
  131. # specifies one:
  132. echo "Searching for required tools ..."
  133. [ -z "$ACLOCAL" ] && ACLOCAL=$(Search aclocal 1)
  134. [ "$VERBOSE" = "1" ] && echo " - ACLOCAL=$ACLOCAL"
  135. [ -z "$AUTOHEADER" ] && AUTOHEADER=$(Search autoheader 2)
  136. [ "$VERBOSE" = "1" ] && echo " - AUTOHEADER=$AUTOHEADER"
  137. [ -z "$AUTOMAKE" ] && AUTOMAKE=$(Search automake 1)
  138. [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE=$AUTOMAKE"
  139. [ -z "$AUTOCONF" ] && AUTOCONF=$(Search autoconf 2)
  140. [ "$VERBOSE" = "1" ] && echo " - AUTOCONF=$AUTOCONF"
  141. AUTOCONF_VERSION=$(echo "$AUTOCONF" | cut -d'-' -f2-)
  142. [ -n "$AUTOCONF_VERSION" ] && [ "$AUTOCONF_VERSION" != "autoconf" ] \
  143. && export AUTOCONF_VERSION || unset AUTOCONF_VERSION
  144. [ "$VERBOSE" = "1" ] && echo " - AUTOCONF_VERSION=$AUTOCONF_VERSION"
  145. AUTOMAKE_VERSION=$(echo $AUTOMAKE | cut -d'-' -f2-)
  146. [ -n "$AUTOMAKE_VERSION" ] && [ "$AUTOMAKE_VERSION" != "automake" ] \
  147. && export AUTOMAKE_VERSION || unset AUTOMAKE_VERSION
  148. [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE_VERSION=$AUTOMAKE_VERSION"
  149. [ $# -gt 0 ] && CONFIGURE_ARGS=" $*" || CONFIGURE_ARGS=""
  150. [ -z "$GO" ] && [ -n "$CONFIGURE_ARGS" ] && GO=1
  151. # Verify that all tools have been found
  152. command -v pkg-config >/dev/null || Notfound pkg-config
  153. [ -z "$ACLOCAL" ] && Notfound aclocal
  154. [ -z "$AUTOHEADER" ] && Notfound autoheader
  155. [ -z "$AUTOMAKE" ] && Notfound automake
  156. [ -z "$AUTOCONF" ] && Notfound autoconf
  157. AM_VERSION=$($AUTOMAKE --version | head -n 1 | sed -e 's/.* //g')
  158. ifs=$IFS; IFS="."; set $AM_VERSION; IFS=$ifs
  159. AM_MAJOR="$1"; AM_MINOR="$2"
  160. echo "Detected automake $AM_VERSION ..."
  161. AM_MAKEFILES="src/ipaddr/Makefile.ng src/ngircd/Makefile.ng src/testsuite/Makefile.ng src/tool/Makefile.ng"
  162. # De-ANSI-fication?
  163. if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -lt "12" ]; then
  164. # automake < 1.12 => automatic de-ANSI-fication support available
  165. echo " - Enabling de-ANSI-fication support."
  166. sed -e "s|^__ng_PROTOTYPES__|AM_C_PROTOTYPES|g" configure.ng >configure.ac
  167. DEANSI_START=""
  168. DEANSI_END=""
  169. else
  170. # automake >= 1.12 => no de-ANSI-fication support available
  171. echo " - Disabling de-ANSI-fication support."
  172. sed -e "s|^__ng_PROTOTYPES__|AC_C_PROTOTYPES|g" configure.ng >configure.ac
  173. DEANSI_START="#"
  174. DEANSI_END=" (disabled by ./autogen.sh script)"
  175. fi
  176. # Serial test harness?
  177. if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -ge "13" ]; then
  178. # automake >= 1.13 => enforce "serial test harness"
  179. echo " - Enforcing serial test harness."
  180. SERIAL_TESTS="serial-tests"
  181. else
  182. # automake < 1.13 => no new test harness, nothing to do
  183. # shellcheck disable=SC2034
  184. SERIAL_TEST=""
  185. fi
  186. sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}ansi2knr${DEANSI_END}|g" \
  187. src/portab/Makefile.ng >src/portab/Makefile.am
  188. for makefile_ng in $AM_MAKEFILES; do
  189. makefile_am=$(echo "$makefile_ng" | sed -e "s|\.ng\$|\.am|g")
  190. sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}../portab/ansi2knr${DEANSI_END}|g" \
  191. $makefile_ng >$makefile_am
  192. done
  193. export ACLOCAL AUTOHEADER AUTOMAKE AUTOCONF
  194. # Generate files
  195. echo "Generating files using \"$AUTOCONF\" and \"$AUTOMAKE\" ..."
  196. Run $ACLOCAL && \
  197. Run $AUTOCONF && \
  198. Run $AUTOHEADER && \
  199. Run $AUTOMAKE --add-missing --no-force
  200. if [ $? -eq 0 ] && [ -x ./configure ]; then
  201. # Success: if we got some parameters we call ./configure and pass
  202. # all of them to it.
  203. NAME=$(grep PACKAGE_STRING= configure | cut -d"'" -f2)
  204. if [ "$GO" = "1" ]; then
  205. [ -n "$PREFIX" ] && p=" --prefix=$PREFIX" || p=""
  206. c="./configure${p}${CONFIGURE_ARGS}"
  207. echo "Okay, autogen.sh for $NAME done."
  208. echo "Calling \"$c\" ..."
  209. $c
  210. exit $?
  211. else
  212. echo "Okay, autogen.sh for $NAME done."
  213. echo "Now run the \"./configure\" script."
  214. exit 0
  215. fi
  216. else
  217. # Failure!?
  218. echo "Error! Check your installation of GNU automake and autoconf!"
  219. exit 1
  220. fi
  221. # -eof-